diff --git b/scripts/discover-pkginstall a/scripts/discover-pkginstall
index 47e1ec0..a3324da 100755
--- b/scripts/discover-pkginstall
+++ a/scripts/discover-pkginstall
@@ -40,7 +40,7 @@ if [ true = "$DISCOVER_PKGINSTALL_ASKING" ] ; then
     db_go
     db_get discover/install_hw_packages
     db_stop
-    echo $RET | sed 's/,//g' 1>&15
+    echo $RET | sed 's/,//g' 1>&8
     exit 0
 fi
 
@@ -75,6 +75,17 @@ usage ()
 {
     cat <<EOF
 usage: $0 [-lnv]
+
+Install packages based on detected hardware.  It will use the
+discover-data database to map from hardware to debian packages, install
+the packages by default.  Packages using module-assistant will be
+automatically built and the result installed if module-assistant is
+installed or pulled in as a dependency.
+
+  -l  list packages
+  -v  be verbose
+  -n  only echo commands, do not run them
+
 EOF
 }
 
@@ -120,17 +131,30 @@ ${verbose} && echo ${packages}
 
 # Build kernel modules from all module-assistant packages.
 assist_modules() {
-    if [ -d /usr/share/modass/overrides ] ; then
-	echo "Invoking module-assistant to build kernel modules"
-	module-assistant prepare
-	for pkg in $packages ; do
-	    if [ -f /usr/share/modass/overrides/$pkg ] ; then
-		module-assistant build $pkg
-		module-assistant install $pkg
-		module-assistant clean $pkg
-	    fi
-	done
+    # Check if any packages supported by module-assistant is installed
+    if [ ! -x /usr/bin/module-assistant ] ; then
+	return # module-assistant not installed, no need to continue
     fi
+    prepared=false
+    for pkg in $packages ; do
+	# Check if this package is supported by module-assistant
+	if module-assistant --text-mode --non-inter list $pkg |
+	    grep -q 'package not installed' ; then
+	    if [ false = "$prepared" ] ; then
+                # Would like to use --non-inter here, but then prepare
+                # exits using 254
+		if module-assistant --text-mode prepare ; then
+		    prepared=true
+		else
+		    echo error: Failed to prepare module-assistant.
+		    return
+		fi
+	    fi
+	    ${verbose} && echo "info: invoking module-assistant to handle $pkg."
+	    module-assistant --text-mode --non-inter \
+		build,install,clean $pkg
+	fi
+    done
 }
 
 if [ "$packages" ] ; then
@@ -141,17 +165,26 @@ if [ "$packages" ] ; then
         # packages.  The redirects are gross hacks to work around
         # debconf file descriptor handling
         tempfile=$(tempfile)
-        DISCOVER_PKGINSTALL_ASKING=true $0 $packages 15>$tempfile
+        DISCOVER_PKGINSTALL_ASKING=true $0 $packages 8>$tempfile
         packages=$(cat $tempfile)
         rm $tempfile
 
         if [ "$packages" ] ; then
-            $nop aptitude install -y $packages
+            if [ -x /usr/bin/debconf-apt-progress ] ; then
+                if [ "$DI_PROGRESS_BAR_VISIBLE" ]; then
+                    debconf_apt_progress_opts=--no-progress
+                else
+                    debconf_apt_progress_opts=
+                fi
+                $nop debconf-apt-progress $debconf_apt_progress_opts -- apt-get install -q -y $packages
+            else
+                $nop apt-get install -y $packages
+            fi
             assist_modules
         fi
     fi
 else
-    ${verbose} && echo "No hardware specific packages found for this machine"
+    ${verbose} && echo "info: no hardware specific packages found for this machine"
 fi
 
 exit 0
